



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【POJ1037】A decorative fence(DP)</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【POJ1037】A decorative fence(DP)</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-16 12:44:48 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><a href="https://vjudge.net/contest/150613#problem/C" rel="external nofollow noreferrer">BUPT2017 wintertraining(15) #6C</a></p>
<h3>题意</h3>
<p>给长度n的数列，1,2,..,n，按依次递增递减排序，求字典序第k小的排列。</p>
<h3>题解</h3>
<p>dp。<br /><br />
up[i][j]表示长度为j,以第i小开头前两个递增的排列有几种。<br /><br />
down[i][j]表示长度为j,以第i小开头前两个递减的排列有几种。<br /><br />
那么有\(down[i][j]=\sum_{k=1}^{k=j-1}up[k][j-1]\)<br /><br />
并且有\(down[1][1]=1\),\(up[i][j]=down[j-i+1][j]\)。<br /><br />
然后就可以递推了。<br /><br />
求第k小的排列，令s[i]=i(i=1,2,…n)，再令i为n到1,从小到大枚举未用过的i个数中第v小的，如果down[v][i]不比k小，说明后面是以第v小开头的长为i的开头递减排列，之后就要找这些排列中第k-down小的了。或判断up，根据标记的fup(表示之前是上升否)。输出s[v]，并移除s[v]。</p>
<h3>代码</h3>
<pre class="prettyprint linenums"><code>#include &lt;cstdio&gt;<br />
#include &lt;cstring&gt;<br />
#include &lt;algorithm&gt;<br />
#include &lt;iostream&gt;<br />
#define N 21<br />
#define ll long long<br />
using namespace std;<br />
int t,n;<br />
ll k;<br />
ll up[N][N],down[N][N];<br />
int s[N];<br />
void get(){<br />
	int fup,v=0;<br />
	for(int i=1;i&lt;=n;i++)s[i]=i;<br />
	for(int i=n;i;i--){//剩下i个位置要放<br />
		if(i==n){<br />
			for(int j=1;j&lt;=n;j++){//放第1小到第n小<br />
				if(k&lt;=down[j][i]){//先考虑下降，因为下降则这个方案更小<br />
					v=j;fup=0;break;//s[j]开头的够算，且是之后一个是上升<br />
				}<br />
				k-=down[j][i];//不够算，则找后面的第k-down大的方案。<br />
				if(k&lt;=up[j][i]){<br />
					v=j;fup=1;break;<br />
				}<br />
				k-=up[j][i];<br />
			}<br />
		}else{<br />
			if(fup){<br />
				for(int j=v;j&lt;=i;j++){<br />
					if(k&lt;=down[j][i]){<br />
						v=j;break;<br />
					}<br />
					k-=down[j][i];<br />
				}<br />
			}else{<br />
				for(int j=1;j&lt;v;j++){<br />
					if(k&lt;=up[j][i]){<br />
						v=j;break;<br />
					}<br />
					k-=up[j][i];<br />
				}<br />
			}<br />
			fup^=1;<br />
		}<br />
		printf(&quot;%d &quot;,s[v]);<br />
		for(int j=v;j&lt;i;j++)s[j]=s[j+1];<br />
	}<br />
	puts(&quot;&quot;);<br />
}<br />
int main() {<br />
	down[1][1]=1;<br />
	for(int i=1;i&lt;N;i++){<br />
		for(int j=2;j&lt;=i;j++)<br />
			down[j][i]=down[j-1][i]+up[j-1][i-1];<br />
			//以第j小开头长度i的下降=sum_{k=1}^{k=j-1}{up[k][i-1]}<br />
			//那么down[j][i]-down[j-1][i]=up[j-1][i-1]<br />
		for(int j=1;j&lt;=i;j++)<br />
			up[j][i]=down[i-j+1][i];<br />
			//第j小开头的上升=第i-j+1大开头的下降<br />
	}<br />
	scanf(&quot;%d&quot;,&amp;t);<br />
	while(t--){<br />
		scanf(&quot;%d%lld&quot;,&amp;n,&amp;k);<br />
		get();<br />
	}<br />
	return 0;<br />
}<br />
</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/6o8k779j.html">SQLSERVER走起微信公众帐号已经开通搜狗微信搜索</a>
		</li>
						<li><a href="https://www.batexi.com/a/495gx70q.html">Android分享一款漂亮的折叠书架菜单</a>
		</li>
						<li><a href="https://www.batexi.com/a/m9657g3q.html">LogConfigruration</a>
		</li>
						<li><a href="https://www.batexi.com/a/49gy6oe9.html">paper 109 ：图像处理中的拉普拉斯算子</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq16pr58.html">js调用父窗口中的方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xn6509.html">mvc的一些知识点</a>
		</li>
						<li><a href="https://www.batexi.com/a/qder2v09.html">使用list和tuple</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnzkzpq.html">WebService的优点和基本原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0g5oeq.html">通用块层、IO调度层以及设备驱动层的数据结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z17o5n9.html">BZOJ3036&colon; 绿豆蛙的归宿&amp;amp&semi;Wikioi2488：绿豆蛙的归宿</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mem476q.html">http 连接复用</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj112x9.html">Launchpad灰色图标怎么删除&quest;重置Launchpad教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy15j6dq.html">实验：Oracle数据泵导出导入之序列问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k4y359.html">平方根的C语言实现&lpar;一&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljwmox9.html">C&num;使用Xamarin开发可移植移动应用进阶篇&lpar;7&period;使用布局渲染器&comma;修改默认布局&rpar;&comma;附源码</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jypnw8.html">java虚拟机概述</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojekrpq.html">SAP MM &amp;&num;39&semi;独立&sol;集中&amp;&num;39&semi;等于1的MTS物料MRP运行后合并需求触发PR</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvv3z38.html">&lbrack;转&rsqb;js 取得 Unix时间戳&lpar;Unix timestamp&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7olkx18.html">对象关系映射&lpar;ORM&rpar;框架GreenDao简介和基本使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/q253kzlq.html">easywechat &lpar;在thinkphp5中使用easywechat完成微信网页认证&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9j1e0rl9.html">JS 有趣的JS</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gj3moe9.html">Python学习第十八篇&mdash;&mdash;低耦合函数设计思想</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdw5po09.html">python实现一个二分查找</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e40ygm9.html">iOS QRcode识别及相册图片二维码读取识别</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e40ydj9.html">网络七层模型及TCP、UDP，一次HTTP请求都发生了什么</a>
			</li>
						<li><a href="https://www.batexi.com/a/960m03n9.html">mysql常用命令小结</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjmox79.html">3proxy&period;cfg 配置文件解析</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjmm039.html">PV、TPS、QPS计算公式（转）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllonm6q.html">MySQL 查询语句中自己定义的中文内容在Java Web 中显示为问号</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kjm5769.html">Web移动端---iPhone X适配（底部栏黑横线）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
